#!/bin/sh
#mulot.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Andr Connes <davidlucardi@aol.com>
#  Copyright (C) 2002 Andr Connes <andre.connes@toulouse.iufm.fr>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : mulot.tcl
#  Author  : Andr Connes <andre.connes@toulouse.iufm.fr>
#  Modifier:
#  Date    : 15/04/2003 modifi le 20/11/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    $Id: Exp $
#  @author     Andr Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Andr Connes
# 
#***********************************************************************
global sysFont glob

source mulot.conf
source msg.tcl
source aider.tcl
source fonts.tcl

set basedir [file dir $argv0]
cd $basedir

#wm resizable . 0 0
. configure -background blue
wm geometry . +0+0
wm title . "[mc {title_m}]"

# gestion de l'espace de l'utilisateur
  if {![file exists [file join  $glob(home_mulot)]]} {
	catch { file mkdir [file join $glob(home_mulot)]}
  }
  if {![file exists [file join  $glob(home_reglages)]]} {
	catch { file mkdir [file join $glob(home_reglages)] }
  }
  #
  # langue par dfaut
  #
  if {![file exists [file join  $glob(home_reglages) lang.conf]]} {
	set f [open [file join $glob(home_reglages) lang.conf] "w"]
	puts $f "fr"
	close $f
  }
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

  if {![file exists [file join  $glob(home_reglages) dir_exos.conf]]} {
	set f [open [file join $glob(home_reglages) dir_exos.conf] "w"]
	puts $f "Commun"
	close $f
  }

  catch { file mkdir [file join $glob(home_msgs)] }
  # astuce suivante : ajoute automatiquement toute nouvelle langue chez l'utilisateur
  foreach f [glob [file join msgs *.msg]] {
	catch { file copy [file join $f] [file join $glob(home_msgs)]}
  }
  if {![file exists [file join  $glob(trace_dir)]]} {
	file mkdir [file join $glob(trace_dir)]
  }
  catch { file mkdir [file join $glob(home_chemin) grilles] }

if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets"
}

proc lanceappli {appli niveau} {
	set appli [file join $appli]
	exec wish $appli $niveau &
}

proc setlang {lang} {
  global env glob
  set env(LANG) $lang
  catch {set f [open [file join $glob(home_reglages) lang.conf] "w"]}
  puts $f [file rootname [file tail $lang]]
  close $f

  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

  main_loop
}

proc setdossier {dossier} {
  global glob
  catch {set f [open [file join $glob(home_reglages) dossier.conf] "w"]}
  puts $f $dossier
  close $f

  lanceappli choisir_activite.tcl 0
}

proc setwindowsusername {} {
    global user
    catch {destroy .utilisateur}
    toplevel .utilisateur -background grey -width 250 -height 100
    wm geometry .utilisateur +50+50
    frame .utilisateur.frame -background grey -width 250 -height 100
    pack .utilisateur.frame -side top
    label .utilisateur.frame.labobj -font {Helvetica 10} -text "[mc {Ton nom}] ?" -background grey
    pack .utilisateur.frame.labobj -side top 
    entry .utilisateur.frame.entobj -font {Helvetica 10} -width 10
    pack .utilisateur.frame.entobj -side top 
    button .utilisateur.frame.ok -background gray75 -text "Ok" -command "verifnom"
    pack .utilisateur.frame.ok -side top -pady 10
}

  proc verifnom {} {
   global glob
   set nom [string tolower [string trim [string map {\040 ""} [.utilisateur.frame.entobj get]]]]
    if {$nom ==""} {
	set nom eleve
    }
    # sauver le rglage du nom
    catch {set f [open [file join $glob(home_mulot) reglages trace_user] "w"]}
    set glob(trace_user) "$glob(trace_dir)/$nom"
    puts $f $glob(trace_user)
    close $f
    catch {destroy .utilisateur}
}

###########################################################################################""
proc main_loop {} {
#  global c sysFont glob progaide
  global sysFont glob

  #
  # Creation du menu utilise comme barre de menu:
  #
  catch {destroy .menu}
  catch { destroy .frame.c}
  catch {destroy .frame}

  menu .menu -tearoff 0
  #
  # Creation du menu Fichier
  #
  menu .menu.fichier -tearoff 0
  .menu add cascade -label [mc {Fichier}] -menu .menu.fichier
  .menu.fichier add command -label [mc {Quitter}] -command exit
  #
  # Creation du menu Options
  #
  menu .menu.options -tearoff 0
  .menu add cascade -label [mc {Options}] -menu .menu.options

  # dossiers
  menu .menu.options.dossiers -tearoff 0 
  .menu.options add cascade -label "[mc {Dossiers}]" -menu .menu.options.dossiers

  #charger la liste des dossiers
  set all_dossiers [glob -directory images -type d *]
  foreach tmp_dossier $all_dossiers {
    if { $tmp_dossier == "images/CVS" } continue
    lappend glob(dossiers) [file tail $tmp_dossier]
  }
  set glob(dossiers) [lsort $glob(dossiers)]

  foreach d $glob(dossiers) {
    .menu.options.dossiers add radio \
	-label $d -variable dossier \
	-command "setdossier $d"
  }

  # langues
#  menu .menu.options.lang -tearoff 0 
#  .menu.options add cascade -label "[mc {Langue}]" -menu .menu.options.lang

#  foreach i [glob [file join  $glob(home_msgs) *.msg]] {
#    set langue [string map {.msg "" } [file tail $i]]
#    .menu.options.lang add radio -label $langue -variable langue -command "setlang $langue"
#  }

  # Nom de l'utilisateur sous windows
  if {$glob(platform) == "windows"} {
    .menu add command -label [mc {Utilisateur}] -command "setwindowsusername"
  }
  #
  # Creation du menu aide
  #
  menu .menu.aide -tearoff 0
  .menu add cascade -label [mc {Aide}] -menu .menu.aide
  .menu.aide add command -label [mc {Aide}] -command aider
  .menu.aide add command -label [mc { propos ...}] -command "source apropos.tcl"

  . configure -menu .menu

  #######################################################################"
  . configure -background blue
  frame .frame -background blue -height 300 -width 200
  pack .frame -side top -fill both -expand yes
  ###################On cre un canvas####################################

  set c .frame.c
  canvas $c -width $glob(width) -height $glob(height) -bg blue -highlightbackground blue
  pack $c -expand true

  set nligne 0
  set ncolonne 0
  foreach d $glob(dossiers) {
      button $c.$d \
        -image [image create photo -file [file join sysdata menu_$d.png]] \
        -borderwidth 10 -cursor heart \
        -command "setdossier $d"
    grid $c.$d -column $ncolonne -row $nligne -sticky e -padx 10 -pady 10
    incr ncolonne
    if { $ncolonne > 2 } {
      set ncolonne 0
      incr nligne
    } 
  }

  if { $nligne == 0 } {
    incr nligne ;# pour un affichage russi !
  }
  button $c.quitter \
        -image [image create photo -file sysdata/quitter.gif] \
        -borderwidth 10 -cursor heart \
        -command exit
  grid $c.quitter -column 3 -row $nligne -sticky e -padx 10 -pady 10

  set myimage [image create photo -file sysdata/background.gif]
  label $c.imagedisplayer -image $myimage -background blue
  grid $c.imagedisplayer -column 3 -row 0 -sticky e

#  label $c.nimages -bg blue
#  grid $c.nimages -column 1 -row 2

} ;# fin main_loop

############
# Bindings #
############
bind . <Control-q> {exit}

########################################################################"

  # Nom de l'utilisateur par dfaut sous windows
  if {$glob(platform) == "windows"} {
    set nom eleve
    # sauver le rglage du nom
    catch {set f [open [file join $glob(home_mulot) reglages trace_user] "w"]}
    puts $f "$glob(trace_dir)/$nom"
    close $f
  }


main_loop

